
__doc__='still to do'

import Globals
from DocumentTemplate.DT_Util import InstanceDict, TemplateDict
from AccessControl import ClassSecurityInfo
from OFS.SimpleItem import SimpleItem
from OFS.FindSupport import FindSupport
from OFS.ObjectManager import ObjectManager

class Namespace:
    """serves TemplateDict names as attributes without invoking them"""
    def __init__(self, td):
        self._ = td
        self.__getitem__ = td.__getitem__
        self.has_key = td.has_key

    def __getattr__(self, name):
        try: return self._.getitem(name, 0)
        except KeyError: raise AttributeError, name


class CallableItem(SimpleItem):
    #################################################
    ## "Don't Forget" attributes :-)
    icon = 'img/HiperDom/HiperDomTemplate.gif'
    

    #################################################
    ## Instance constructors

    def __init__ (self, id):
        "Initialize the class instance"
        self.id = id
        for name, value in self._prototype_attrs.items ():
            if not hasattr (self, name):
                setattr (self, name, value)

    # to upgrade from older versions of your derived objects,
    # override these two variables
    _prototype_attrs = {} # variables (and values) old versions don't have
    _deprecated_attrs = () # variables not needed on newer versions
    
    def __setstate__ (self, state):
        "Initialize when loading from the ZODB"
        Globals.Persistent.__setstate__ (self, state)
        for name, value in self._prototype_attrs.items ():
            if not hasattr (self, name):
                setattr (self, name, value)
        for name in self._deprecated_attrs:
            if hasattr (self, name):
                delattr (self, name)

    # Prevent accidental acquisition
    index_html = None

    # Security related (?)
    validate = None
    validate__roles__ = ()

    security = ClassSecurityInfo()

    # We pretend to be a function, just like DTML* objects
    class func_code:
        __roles__ = ()
        co_varnames = 'self','REQUEST','RESPONSE'
        co_argcount=3

    func_code=func_code()

    func_defaults__roles__=()
    func_defaults=()

    security.declarePublic('__call__')
    def __call__ (self, client=None, REQUEST=None, RESPONSE=None, **kw):
        "Render or publish this object"

        # I think this is for securely getting directly to the object
        # with no aquisition involved, but who knows...
        bself = getattr(self, 'aq_explicit', self)

        # number of things we pushed into namespace, see below
        pushed = 0
        # Now build a TemplateDict if necessary. This will be our context.
        if getattr(REQUEST, '__class__', None) is TemplateDict:
            td = REQUEST
            # We participate nicely, so we also play along with the levels.
            if td.level > 200:
                raise SystemError, ('infinite recursion in document template')
        else:
            td = TemplateDict()
            if REQUEST:
                td._push(REQUEST)
                pushed = pushed + 1
            elif hasattr(self, 'REQUEST'):
                td._push(self.REQUEST)
                pushed = pushed + 1
            td.validate = self.validate
            td.this = bself
        level = td.level # so that we can restore later
        td.level = td.level + 1

        # now we push into the namespace the objects we want there, in order
        if client is not None:
            td._push(InstanceDict(client, td))
            pushed = pushed + 1
        # including myself.
        td._push(InstanceDict(bself, td))
        pushed = pushed + 1

        if kw:
            td._push(kw)
            pushed = pushed + 1

        # now we try to call publish or render depending if we were
        # called directly or in a subtemplate (respectively)
        try:
            if client:
                return bself.publish(Namespace(td))
            else:
                return bself.render(Namespace(td))
        finally:
            # we put a reference to ourselves in the list (either
            # as client or as bself). If we don't remove it we will
            # leak a circular reference, so we remove everything we
            # put into namespace
            td._pop(pushed)
            td.level = level # Restore previous level

    security.declarePublic('publish')
    def publish(self, namespace=None):
        "called when self is published from the URL"
        return self.render(namespace)

    security.declarePublic('render')
    def render(self, namespace=None):
        "called when self is published as sub-template"
        return "You forgot to override 'CallableItem.render()'\n"

Globals.InitializeClass(CallableItem)

class tabs:
    print "*** talvez substituir os abaixo por referencias como as do contents"
    base = ({'label':'Undo', 'action':'manage_UndoForm',
             'help': ('OFSP', 'Undo.stx')},
            {'label':'Ownership', 'action':'manage_owner',
             'help': ('OFSP', 'Ownership.stx')},
            {'label':'Security', 'action':'manage_access',
             'help': ('OFSP', 'Security.stx')},
            )
    view = ({'label':'View', 'action':''},)
    properties = ({'label':'Properties', 'action':'manage_propertiesForm',
                   'help': ('OFSP', 'Properties.stx')}, )
    contents = (ObjectManager.manage_options[0],)
    find = FindSupport.manage_options

#tabs = tabs()
